diff --git a/src/modules/Extensions/YouTube.hpp b/src/modules/Extensions/YouTube.hpp
index 4c83d8f4..4d7535e5 100644
--- a/src/modules/Extensions/YouTube.hpp
+++ b/src/modules/Extensions/YouTube.hpp
@@ -26,6 +26,9 @@
 #include <QPointer>
 #include <QMutex>
 
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+
 class NetworkReply;
 class QProgressBar;
 class QActionGroup;
@@ -45,7 +48,7 @@ enum class PreferredCodec
 
 /**/
 
-class ResultsYoutube final : public QTreeWidget
+class ResultsYoutube : public QTreeWidget
 {
     Q_OBJECT
 public:
@@ -70,13 +73,16 @@ private slots:
     void showRelated();
 
     void contextMenu(const QPoint &p);
+
+    void playAction();
+    void enqueueAction();
 };
 
 /**/
 
 class YouTube;
 
-class PageSwitcher final : public QWidget
+class PageSwitcher : public QWidget
 {
     Q_OBJECT
 public:
@@ -90,7 +96,7 @@ public:
 
 using ItagNames = QPair<QStringList, QList<int>>;
 
-class YouTube final : public QWidget, public QMPlay2Extensions
+class YouTube : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -101,19 +107,19 @@ public:
     YouTube(Module &module);
     ~YouTube();
 
-    bool set() override;
+    bool set();
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    bool canConvertAddress() const override;
+    bool canConvertAddress() const;
 
-    QString matchAddress(const QString &url) const override;
-    QList<AddressPrefix> addressPrefixList(bool) const override;
-    void convertAddress(const QString &, const QString &, const QString &, QString *, QString *, QIcon *, QString *, IOController<> *ioCtrl) override;
+    QString matchAddress(const QString &url) const;
+    QList<AddressPrefix> addressPrefixList(bool) const;
+    void convertAddress(const QString &, const QString &, const QString &, QString *, QString *, QIcon *, QString *, IOController<> *ioCtrl);
 
-    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override;
+    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &);
 
-public:
+public slots:
     void chPage();
 
 private slots:
@@ -128,6 +134,11 @@ private slots:
 
     void searchMenu();
 
+    void showSettings();
+    void onQualityActionTriggered();
+    void onQualityActionToggled(bool checked);
+    void onSortByActionTriggered();
+
 private:
     void prepareSearch();
 
@@ -166,6 +177,8 @@ private:
     bool m_allowSubtitles;
 
     QActionGroup *m_qualityGroup = nullptr, *m_sortByGroup = nullptr;
+    QHash<QAction*, int> m_qualityActionToIndex;
+    QHash<QAction*, int> m_sortByActionToIndex;
 
     int m_sortByIdx = 0;
 
diff --git a/src/modules/FFmpeg/D3D11VAVulkan.hpp b/src/modules/FFmpeg/D3D11VAVulkan.hpp
index ba8af7c4..202f5bb8 100644
--- a/src/modules/FFmpeg/D3D11VAVulkan.hpp
+++ b/src/modules/FFmpeg/D3D11VAVulkan.hpp
@@ -46,12 +46,12 @@ public:
     D3D11VAVulkan(AVBufferRef *hwDeviceBufferRef, bool zeroCopyAllowed);
     ~D3D11VAVulkan();
 
-    QString name() const override;
+    QString name() const;
 
-    void map(Frame &frame) override;
-    void clear() override;
+    void map(Frame &frame);
+    void clear();
 
-    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo) override;
+    SyncDataPtr sync(const std::vector<Frame> &frames, vk::SubmitInfo *submitInfo);
 
 public:
     bool init();
diff --git a/src/modules/FFmpeg/DXVA2OpenGL.cpp b/src/modules/FFmpeg/DXVA2OpenGL.cpp
index 02f9cc8d..4da94095 100644
--- a/src/modules/FFmpeg/DXVA2OpenGL.cpp
+++ b/src/modules/FFmpeg/DXVA2OpenGL.cpp
@@ -21,7 +21,7 @@
 #include <QMPlay2Core.hpp>
 #include <Frame.hpp>
 
-#include <QOpenGLFunctions>
+#include <QtOpenGL/QGLContext>
 #include <QLibrary>
 
 extern "C"
@@ -64,7 +64,8 @@ DXVA2OpenGL::~DXVA2OpenGL()
     {
         for (int i = 0; i < s_numRenderTargets; ++i)
         {
-            for (auto &&renderTarget : std::as_const(m_renderTargets[i].surfaces))
+            // Qt4: No std::as_const
+            foreach (auto renderTarget, m_renderTargets[i].surfaces)
                 renderTarget->Release();
         }
     }
@@ -92,7 +93,8 @@ bool DXVA2OpenGL::init(const int *widths, const int *heights, const SetTexturePa
         m_width = widths[0];
         m_height = heights[0];
 
-        QOpenGLContext::currentContext()->functions()->glGenTextures(2, m_textures);
+        // Qt4: Use OpenGL functions directly
+        glGenTextures(2, m_textures);
     }
 
     for (int i = 0; i < 2; ++i)
@@ -106,7 +108,8 @@ bool DXVA2OpenGL::init(const int *widths, const int *heights, const SetTexturePa
         return ret;
     }
 
-    auto context = QOpenGLContext::currentContext();
+    // Qt4: Use QGLContext instead of QOpenGLContext
+    auto context = QGLContext::currentContext();
     if (!context)
     {
         QMPlay2Core.logError("DXVA2 :: Unable to get OpenGL context");
@@ -339,7 +342,7 @@ bool DXVA2OpenGL::checkCodec(const QByteArray &codecName, bool b10)
 
         for (UINT i = 0; i < count; ++i)
         {
-            for (const GUID *guid : std::as_const(neededCodecGUIDs))
+            for (const GUID *guid : neededCodecGUIDs)
             {
                 if (IsEqualGUID(codecGUIDs[i], *guid))
                 {
@@ -498,7 +501,8 @@ void DXVA2OpenGL::clearTextures()
         }
     }
 
-    QOpenGLContext::currentContext()->functions()->glDeleteTextures(2, m_textures);
+    // Qt4: Use OpenGL functions directly
+    glDeleteTextures(2, m_textures);
     memset(m_textures, 0, sizeof(m_textures));
     m_width = m_height = 0;
 }
diff --git a/src/modules/FFmpeg/DXVA2OpenGL.hpp b/src/modules/FFmpeg/DXVA2OpenGL.hpp
index cd968292..2c6d0099 100644
--- a/src/modules/FFmpeg/DXVA2OpenGL.hpp
+++ b/src/modules/FFmpeg/DXVA2OpenGL.hpp
@@ -20,7 +20,7 @@
 
 #include <opengl/OpenGLHWInterop.hpp>
 
-#include <QOpenGLContext>
+#include <QtOpenGL/QGLContext>
 #include <QHash>
 
 #include <functional>
@@ -41,20 +41,20 @@ public:
     DXVA2OpenGL(AVBufferRef *hwDeviceBufferRef);
     ~DXVA2OpenGL();
 
-    QString name() const override;
+    QString name() const;
 
-    Format getFormat() const override;
+    Format getFormat() const;
 
-    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn) override;
-    void clear() override;
+    bool init(const int *widths, const int *heights, const SetTextureParamsFn &setTextureParamsFn);
+    void clear();
 
-    bool mapFrame(Frame &videoFrame) override;
-    quint32 getTexture(int plane) override;
+    bool mapFrame(Frame &videoFrame);
+    quint32 getTexture(int plane);
 
-    Frame getCpuFrame(const Frame &videoFrame) override;
+    Frame getCpuFrame(const Frame &videoFrame);
 
-    void getVideAdjustmentCap(VideoAdjustment &videoAdjustmentCap) override;
-    void setVideoAdjustment(const VideoAdjustment &videoAdjustment) override;
+    void getVideAdjustmentCap(VideoAdjustment &videoAdjustmentCap);
+    void setVideoAdjustment(const VideoAdjustment &videoAdjustment);
 
     /**/
 
diff --git a/src/modules/FFmpeg/FFCommon.cpp b/src/modules/FFmpeg/FFCommon.cpp
index 351d590c..07348858 100644
--- a/src/modules/FFmpeg/FFCommon.cpp
+++ b/src/modules/FFmpeg/FFCommon.cpp
@@ -18,7 +18,7 @@
 
 #include <FFCommon.hpp>
 
-#include <QRegularExpression>
+#include <QRegExp>
 #include <QProcess>
 #include <QSysInfo>
 #include <QDebug>
@@ -57,9 +57,13 @@ void FFCommon::setDriversPath(const QString &dirName, const QByteArray &envVar)
         if (maps.open(QFile::ReadOnly | QFile::Text))
         {
             const auto lines = maps.readAll().split('\n');
+            // Qt4: Use QRegExp instead of QRegularExpression
+            QRegExp rx("(/usr/lib/\\S+-linux-gnu)/.+\\.so($|\\.)");
             for (auto &&line : lines)
             {
-                const auto dir = QRegularExpression(R"((\/usr\/lib\/\S+-linux-gnu)\/.+\.so($|\.))").match(line).captured(1).toUtf8();
+                QByteArray dir;
+                if (rx.indexIn(line) != -1)
+                    dir = rx.cap(1).toUtf8();
                 if (!dir.isEmpty())
                 {
                     if (!dirs.contains(dir))
diff --git a/src/modules/FFmpeg/FFDec.hpp b/src/modules/FFmpeg/FFDec.hpp
index 3cca114b..ed40f042 100644
--- a/src/modules/FFmpeg/FFDec.hpp
+++ b/src/modules/FFmpeg/FFDec.hpp
@@ -46,9 +46,9 @@ protected:
     FFDec();
     ~FFDec();
 
-    void setSupportedPixelFormats(const AVPixelFormats &pixelFormats) override;
+    void setSupportedPixelFormats(const AVPixelFormats &pixelFormats);
 
-    int pendingFrames() const override;
+    int pendingFrames() const;
 
     /**/
 
diff --git a/src/modules/FFmpeg/FFDecD3D11VA.hpp b/src/modules/FFmpeg/FFDecD3D11VA.hpp
index decc75bc..01b29051 100644
--- a/src/modules/FFmpeg/FFDecD3D11VA.hpp
+++ b/src/modules/FFmpeg/FFDecD3D11VA.hpp
@@ -27,19 +27,19 @@
 class D3D11VAVulkan;
 struct SwsContext;
 
-class FFMPEG_EXPORT FFDecD3D11VA final : public FFDecHWAccel
+class FFMPEG_EXPORT FFDecD3D11VA : public FFDecHWAccel
 {
 public:
     FFDecD3D11VA(Module &module);
     ~FFDecD3D11VA();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
+    QString name() const;
 
-    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp) override;
+    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp);
 
-    bool open(StreamInfo &streamInfo) override;
+    bool open(StreamInfo &streamInfo);
 
 private:
     bool comparePrimaryDevice() const;
diff --git a/src/modules/FFmpeg/FFDecDXVA2.hpp b/src/modules/FFmpeg/FFDecDXVA2.hpp
index 38846856..7f326348 100644
--- a/src/modules/FFmpeg/FFDecDXVA2.hpp
+++ b/src/modules/FFmpeg/FFDecDXVA2.hpp
@@ -20,19 +20,19 @@
 
 #include <FFDecHWAccel.hpp>
 
-class FFMPEG_EXPORT FFDecDXVA2 final : public FFDecHWAccel
+class FFMPEG_EXPORT FFDecDXVA2 : public FFDecHWAccel
 {
 public:
     FFDecDXVA2(Module &module);
     ~FFDecDXVA2();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
+    QString name() const;
 
-    std::shared_ptr<VideoFilter> hwAccelFilter() const override;
+    std::shared_ptr<VideoFilter> hwAccelFilter() const;
 
-    bool open(StreamInfo &streamInfo) override;
+    bool open(StreamInfo &streamInfo);
 
 private:
     AVBufferRef *m_hwDeviceBufferRef = nullptr;
diff --git a/src/modules/FFmpeg/FFDecHWAccel.hpp b/src/modules/FFmpeg/FFDecHWAccel.hpp
index e3ffcada..b73c91d5 100644
--- a/src/modules/FFmpeg/FFDecHWAccel.hpp
+++ b/src/modules/FFmpeg/FFDecHWAccel.hpp
@@ -28,13 +28,13 @@ protected:
 
     static bool hasHWAccel(const char *hwaccelName);
 
-    AVCodec *init(StreamInfo &streamInfo) override;
+    AVCodec *init(StreamInfo &streamInfo);
 
     bool hasHWDecContext() const override final;
 
-    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp) override;
+    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp);
 
-    bool hasCriticalError() const override;
+    bool hasCriticalError() const;
 
 protected:
     bool m_hasCriticalError = false;
diff --git a/src/modules/FFmpeg/FFDecSW.cpp b/src/modules/FFmpeg/FFDecSW.cpp
index 8928daef..4bf618e4 100644
--- a/src/modules/FFmpeg/FFDecSW.cpp
+++ b/src/modules/FFmpeg/FFDecSW.cpp
@@ -24,6 +24,8 @@
 #include <StreamInfo.hpp>
 #include <Functions.hpp>
 
+#include <cmath>
+
 #ifdef USE_VULKAN
 #   include "../qmvk/MemoryPropertyFlags.hpp"
 #   include "../qmvk/PhysicalDevice.hpp"
@@ -266,14 +268,14 @@ int FFDecSW::decodeAudio(const Packet &encodedPacket, QByteArray &decoded, doubl
             ts = frame->best_effort_timestamp * av_q2d(m_timeBase);
         else if (encodedPacket.hasDts() || encodedPacket.hasPts())
             ts = encodedPacket.ts();
-        else if (codec_ctx->codec_id == AV_CODEC_ID_APE && !qIsNaN(m_lastTs))
+        else if (codec_ctx->codec_id == AV_CODEC_ID_APE && !std::isnan(m_lastTs))
             ts = m_lastTs + static_cast<double>(frame->nb_samples) / static_cast<double>(sampleRate);
         else
-            ts = qQNaN();
+            ts = std::numeric_limits<double>::quiet_NaN();
     }
     else
     {
-        ts = qQNaN();
+        ts = std::numeric_limits<double>::quiet_NaN();
     }
 
     m_lastTs = ts;
@@ -420,7 +422,7 @@ bool FFDecSW::decodeSubtitle(const QVector<Packet> &encodedPackets, double pos,
         }
     }
 
-    return qIsNaN(pos)
+    return std::isnan(pos)
         ? true
         : getFromBitmapSubsBuffer(osd, pos)
     ;
@@ -548,7 +550,7 @@ void FFDecSW::setPixelFormat()
 
     const QByteArray srcPixFmtName = srcPixDesc->name;
 
-    for (const AVPixelFormat pixFmt : std::as_const(m_supportedPixelFormats))
+    for (const AVPixelFormat pixFmt : m_supportedPixelFormats)
     {
         if (!sws_isSupportedOutput(pixFmt))
             continue;
diff --git a/src/modules/FFmpeg/FFDecSW.hpp b/src/modules/FFmpeg/FFDecSW.hpp
index 8e8c5c9c..0b3f215a 100644
--- a/src/modules/FFmpeg/FFDecSW.hpp
+++ b/src/modules/FFmpeg/FFDecSW.hpp
@@ -18,6 +18,8 @@
 
 #pragma once
 
+#include <limits>
+
 #include <FFDec.hpp>
 
 #include <deque>
@@ -49,7 +51,7 @@ public:
 
 struct SwsContext;
 
-class FFMPEG_EXPORT FFDecSW final : public FFDec
+class FFMPEG_EXPORT FFDecSW : public FFDec
 {
 public:
     FFDecSW(Module &);
@@ -57,20 +59,20 @@ public:
 private:
     ~FFDecSW();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
+    QString name() const;
 
-    QByteArray subtitleHeader() const override;
+    QByteArray subtitleHeader() const;
 
-    void setSupportedPixelFormats(const AVPixelFormats &pixelFormats) override;
+    void setSupportedPixelFormats(const AVPixelFormats &pixelFormats);
 
-    int  decodeAudio(const Packet &encodedPacket, QByteArray &decoded, double &ts, quint8 &channels, quint32 &sampleRate, bool flush) override;
-    int  decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurry_up) override;
-    bool decodeSubtitle(const QVector<Packet> &encodedPackets, double pos, std::shared_ptr<QMPlay2OSD> &osd, const QSize &size, bool flush) override;
-    QList<QByteArray> decodeSubtitle(const Packet &encodedPacket) override;
+    int  decodeAudio(const Packet &encodedPacket, QByteArray &decoded, double &ts, quint8 &channels, quint32 &sampleRate, bool flush);
+    int  decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurry_up);
+    bool decodeSubtitle(const QVector<Packet> &encodedPackets, double pos, std::shared_ptr<QMPlay2OSD> &osd, const QSize &size, bool flush);
+    QList<QByteArray> decodeSubtitle(const Packet &encodedPacket);
 
-    bool open(StreamInfo &) override;
+    bool open(StreamInfo &);
 
     /**/
 
@@ -98,7 +100,7 @@ private:
 
     std::deque<Subtitle> m_subtitles;
 
-    double m_lastTs = qQNaN();
+    double m_lastTs = std::numeric_limits<double>::quiet_NaN();
 
 #ifdef USE_VULKAN
     std::shared_ptr<QmVk::BufferPool> m_vkBufferPool;
diff --git a/src/modules/FFmpeg/FFDecVAAPI.cpp b/src/modules/FFmpeg/FFDecVAAPI.cpp
index b27333db..dc2a1322 100644
--- a/src/modules/FFmpeg/FFDecVAAPI.cpp
+++ b/src/modules/FFmpeg/FFDecVAAPI.cpp
@@ -156,7 +156,7 @@ bool FFDecVAAPI::open(StreamInfo &streamInfo)
 
 #if defined(USE_OPENGL) || defined(USE_VULKAN)
     auto maybeResetVaapi = [this, codec] {
-        if (m_vaapi && m_vaapi->m_codecId != codec->id && m_vaapi->m_isMesaRadeon && m_vaapi->m_driverVersion >= QVersionNumber(22, 0, 0))
+        if (m_vaapi && m_vaapi->m_codecId != codec->id && m_vaapi->m_isMesaRadeon && m_vaapi->m_driverVersion >= SimpleVersion(22, 0, 0))
             m_vaapi.reset();
     };
 #endif
diff --git a/src/modules/FFmpeg/FFDecVAAPI.hpp b/src/modules/FFmpeg/FFDecVAAPI.hpp
index dcc6b6f2..16df855f 100644
--- a/src/modules/FFmpeg/FFDecVAAPI.hpp
+++ b/src/modules/FFmpeg/FFDecVAAPI.hpp
@@ -28,21 +28,21 @@ class VAAPIOpenGL;
 class VAAPIVulkan;
 #endif
 
-class FFMPEG_EXPORT FFDecVAAPI final : public FFDecHWAccel
+class FFMPEG_EXPORT FFDecVAAPI : public FFDecHWAccel
 {
 public:
     FFDecVAAPI(Module &);
     ~FFDecVAAPI();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
+    QString name() const;
 
-    std::shared_ptr<VideoFilter> hwAccelFilter() const override;
+    std::shared_ptr<VideoFilter> hwAccelFilter() const;
 
-    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp) override;
+    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp);
 
-    bool open(StreamInfo &streamInfo) override;
+    bool open(StreamInfo &streamInfo);
 
 private:
     void maybeClearHwSurfaces();
diff --git a/src/modules/FFmpeg/FFDecVTB.hpp b/src/modules/FFmpeg/FFDecVTB.hpp
index 52cb1bab..82c08ab1 100644
--- a/src/modules/FFmpeg/FFDecVTB.hpp
+++ b/src/modules/FFmpeg/FFDecVTB.hpp
@@ -20,17 +20,17 @@
 
 #include <FFDecHWAccel.hpp>
 
-class FFMPEG_EXPORT FFDecVTB final : public FFDecHWAccel
+class FFMPEG_EXPORT FFDecVTB : public FFDecHWAccel
 {
 public:
     FFDecVTB(Module &module);
     ~FFDecVTB();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open(StreamInfo &streamInfo) override;
+    bool open(StreamInfo &streamInfo);
 
 private:
     AVBufferRef *m_hwDeviceBufferRef = nullptr;
diff --git a/src/modules/FFmpeg/FFDecVkVideo.hpp b/src/modules/FFmpeg/FFDecVkVideo.hpp
index 1ec6c304..cc0e32f9 100644
--- a/src/modules/FFmpeg/FFDecVkVideo.hpp
+++ b/src/modules/FFmpeg/FFDecVkVideo.hpp
@@ -33,19 +33,19 @@ class Device;
 
 }
 
-class FFMPEG_EXPORT FFDecVkVideo final : public FFDecHWAccel
+class FFMPEG_EXPORT FFDecVkVideo : public FFDecHWAccel
 {
 public:
     FFDecVkVideo(Module &module, bool hwDownload);
     ~FFDecVkVideo();
 
-    bool set() override;
+    bool set();
 
-    QString name() const override;
+    QString name() const;
 
-    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp) override;
+    int decodeVideo(const Packet &encodedPacket, Frame &decoded, AVPixelFormat &newPixFmt, bool flush, unsigned hurryUp);
 
-    bool open(StreamInfo &streamInfo) override;
+    bool open(StreamInfo &streamInfo);
 
 private:
     bool initHw();
diff --git a/src/modules/FFmpeg/FFDemux.cpp b/src/modules/FFmpeg/FFDemux.cpp
index f250a158..a0081939 100644
--- a/src/modules/FFmpeg/FFDemux.cpp
+++ b/src/modules/FFmpeg/FFDemux.cpp
@@ -35,7 +35,7 @@ FFDemux::FFDemux(Module &module) :
 FFDemux::~FFDemux()
 {
     streams_info.clear();
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
         delete fmtCtx;
 }
 
@@ -63,7 +63,7 @@ bool FFDemux::set()
 bool FFDemux::metadataChanged() const
 {
     bool isMetadataChanged = false;
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
         isMetadataChanged |= fmtCtx->metadataChanged();
     return isMetadataChanged;
 }
@@ -71,7 +71,7 @@ bool FFDemux::metadataChanged() const
 bool FFDemux::isStillImage() const
 {
     bool stillImage = true;
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
         stillImage &= fmtCtx->isStillImage();
     return stillImage;
 }
@@ -92,7 +92,7 @@ QList<ChapterInfo> FFDemux::getChapters() const
 QString FFDemux::name() const
 {
     QString name;
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
     {
         const QString fmtCtxName = fmtCtx->name();
         if (!name.contains(fmtCtxName))
@@ -122,7 +122,7 @@ bool FFDemux::getReplayGain(bool album, float &gain_db, float &peak) const
 qint64 FFDemux::size() const
 {
     qint64 bytes = -1;
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
     {
         const qint64 s = fmtCtx->size();
         if (s < 0)
@@ -134,14 +134,14 @@ qint64 FFDemux::size() const
 double FFDemux::length() const
 {
     double length = -1.0;
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
         length = qMax(length, fmtCtx->length());
     return length;
 }
 int FFDemux::bitrate() const
 {
     int bitrate = 0;
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
         bitrate += fmtCtx->bitrate();
     return bitrate;
 }
@@ -154,7 +154,7 @@ QByteArray FFDemux::image(bool forceCopy) const
 
 bool FFDemux::localStream() const
 {
-    for (const FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (const FormatContext *fmtCtx : formatContexts)
         if (!fmtCtx->isLocal)
             return false;
     return true;
@@ -164,7 +164,7 @@ void FFDemux::selectStreams(const QSet<int> &selectedStreams)
 {
     bool first = true;
     int baseIdx = 0;
-    for (FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (FormatContext *fmtCtx : formatContexts)
     {
         if (first)
         {
@@ -187,7 +187,7 @@ void FFDemux::selectStreams(const QSet<int> &selectedStreams)
 bool FFDemux::seek(double pos, bool backward)
 {
     bool seeked = false;
-    for (FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (FormatContext *fmtCtx : formatContexts)
     {
         if (fmtCtx->seek(pos, backward))
             seeked |= true;
@@ -237,13 +237,13 @@ bool FFDemux::read(Packet &encoded, int &idx)
 }
 void FFDemux::pause()
 {
-    for (FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (FormatContext *fmtCtx : formatContexts)
         fmtCtx->pause();
 }
 void FFDemux::abort()
 {
     QMutexLocker mL(&mutex);
-    for (FormatContext *fmtCtx : std::as_const(formatContexts))
+    for (FormatContext *fmtCtx : formatContexts)
         fmtCtx->abort();
     abortFetchTracks = true;
 }
@@ -257,7 +257,7 @@ bool FFDemux::open(const QString &entireUrl)
     {
         if (!param.isEmpty())
             addFormatContext(url, param);
-        else for (QString stream : url.split("][", Qt::SkipEmptyParts))
+        else for (QString stream : url.split("][", QString::SkipEmptyParts))
         {
             stream.remove('[');
             stream.remove(']');
@@ -455,7 +455,7 @@ Playlist::Entries FFDemux::fetchTracks(const QString &url, bool &ok)
                 const double end = indexes.value(i + 1, {-1.0, -1.0}).first;
                 if (entry.url.isEmpty() || start < 0.0 || (end <= 0.0 && !lastItem))
                 {
-                    entries.removeAt(i);
+                    entries.remove(i);
                     continue;
                 }
                 const QString param = QString("CUE:%1:%2").arg(start).arg(end);
diff --git a/src/modules/FFmpeg/FFDemux.hpp b/src/modules/FFmpeg/FFDemux.hpp
index 9d7a3531..b0ff3ce0 100644
--- a/src/modules/FFmpeg/FFDemux.hpp
+++ b/src/modules/FFmpeg/FFDemux.hpp
@@ -22,7 +22,7 @@
 
 class FormatContext;
 
-class FFDemux final : public Demuxer
+class FFDemux : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(FFDemux)
 public:
@@ -30,36 +30,36 @@ public:
 private:
     ~FFDemux();
 
-    bool set() override;
+    bool set();
 
-    bool metadataChanged() const override;
+    bool metadataChanged() const;
 
-    bool isStillImage() const override;
+    bool isStillImage() const;
 
-    QList<ProgramInfo> getPrograms() const override;
-    QList<ChapterInfo> getChapters() const override;
+    QList<ProgramInfo> getPrograms() const;
+    QList<ChapterInfo> getChapters() const;
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    bool getReplayGain(bool album, float &gain_db, float &peak) const override;
-    qint64 size() const override;
-    double length() const override;
-    int bitrate() const override;
-    QByteArray image(bool forceCopy) const override;
+    QString name() const;
+    QString title() const;
+    QList<QMPlay2Tag> tags() const;
+    bool getReplayGain(bool album, float &gain_db, float &peak) const;
+    qint64 size() const;
+    double length() const;
+    int bitrate() const;
+    QByteArray image(bool forceCopy) const;
 
-    bool localStream() const override;
+    bool localStream() const;
 
-    void selectStreams(const QSet<int> &selectedStreams) override;
+    void selectStreams(const QSet<int> &selectedStreams);
 
-    bool seek(double pos, bool backward) override;
-    bool read(Packet &encoded, int &idx) override;
-    void pause() override;
-    void abort() override;
+    bool seek(double pos, bool backward);
+    bool read(Packet &encoded, int &idx);
+    void pause();
+    void abort();
 
-    bool open(const QString &entireUrl) override;
+    bool open(const QString &entireUrl);
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok);
 
     /**/
 
diff --git a/src/modules/FFmpeg/FFReader.cpp b/src/modules/FFmpeg/FFReader.cpp
index c538d101..880c833b 100644
--- a/src/modules/FFmpeg/FFReader.cpp
+++ b/src/modules/FFmpeg/FFReader.cpp
@@ -49,7 +49,7 @@ public:
     }
 
 private:
-    void run() override
+    void run()
     {
         const AVIOInterruptCB interruptCB = {(int(*)(void*))::interruptCB, &m_abortCtx->isAborted};
         avio_open2(&m_avioCtx, m_url, AVIO_FLAG_READ, &interruptCB, &m_options);
diff --git a/src/modules/FFmpeg/FFReader.hpp b/src/modules/FFmpeg/FFReader.hpp
index c707ed9a..0aa4a8a1 100644
--- a/src/modules/FFmpeg/FFReader.hpp
+++ b/src/modules/FFmpeg/FFReader.hpp
@@ -24,25 +24,25 @@
 
 struct AVIOContext;
 
-class FFReader final : public Reader
+class FFReader : public Reader
 {
 public:
     FFReader();
 private:
-    bool readyRead() const override;
-    bool canSeek() const override;
+    bool readyRead() const;
+    bool canSeek() const;
 
-    bool seek(qint64) override;
-    QByteArray read(qint64) override;
-    void pause() override;
-    bool atEnd() const override;
-    void abort() override;
+    bool seek(qint64);
+    QByteArray read(qint64);
+    void pause();
+    bool atEnd() const;
+    void abort();
 
-    qint64 size() const override;
-    qint64 pos() const override;
-    QString name() const override;
+    qint64 size() const;
+    qint64 pos() const;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
     /**/
 
diff --git a/src/modules/FFmpeg/FFmpeg.cpp b/src/modules/FFmpeg/FFmpeg.cpp
index 8b45a0bd..6c3b72ce 100644
--- a/src/modules/FFmpeg/FFmpeg.cpp
+++ b/src/modules/FFmpeg/FFmpeg.cpp
@@ -45,8 +45,7 @@ extern "C"
 #endif
 }
 
-#include <QOperatingSystemVersion>
-#include <QGuiApplication>
+#include <QApplication>
 #include <QComboBox>
 
 FFmpeg::FFmpeg() :
@@ -67,7 +66,21 @@ FFmpeg::FFmpeg() :
 #if defined(QMPlay2_DXVA2) || defined(QMPlay2_D3D11VA)
     dxIcon = QIcon(":/DXVA2.svgz");
     if (QMPlay2Core.isVulkanRenderer())
+    {
+#ifdef Q_OS_WIN
+        // D3D11VA requires Windows 8 or later
+        // In Qt4, we use QSysInfo for Windows version detection
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         d3d11vaSupported = (QOperatingSystemVersion::current() >= QOperatingSystemVersion::Windows8);
+#else
+        // Qt4: Check Windows version using QSysInfo
+        // Windows 8 is version 6.2
+        d3d11vaSupported = (QSysInfo::WindowsVersion >= QSysInfo::WV_WINDOWS8);
+#endif
+#else
+        d3d11vaSupported = false; // Not Windows
+#endif
+    }
     else
         dxva2Supported = true;
 #endif
@@ -80,6 +93,7 @@ FFmpeg::FFmpeg() :
     init("AllowExperimental", false);
     init("DecoderEnabled", true);
 #ifdef QMPlay2_VKVIDEO
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     switch (QOperatingSystemVersion::currentType())
     {
         case QOperatingSystemVersion::Windows:
@@ -89,6 +103,16 @@ FFmpeg::FFmpeg() :
             init("DecoderVkVideoEnabled", true);
             break;
     }
+#else
+    // Qt4 compatibility: Use preprocessor to determine OS
+#ifdef Q_OS_WIN
+    // VkVideo requires Windows 10 or later in Qt4
+    // Windows 10 is version 6.4 (QSysInfo doesn't have WV_WINDOWS10, so enable for Windows 8+)
+    init("DecoderVkVideoEnabled", QSysInfo::WindowsVersion >= QSysInfo::WV_WINDOWS8);
+#else
+    init("DecoderVkVideoEnabled", true);
+#endif
+#endif
 #endif
 #ifdef QMPlay2_VAAPI
     init("DecoderVAAPIEnabled", true);
diff --git a/src/modules/FFmpeg/FFmpeg.hpp b/src/modules/FFmpeg/FFmpeg.hpp
index 25de8ce1..b75dd268 100644
--- a/src/modules/FFmpeg/FFmpeg.hpp
+++ b/src/modules/FFmpeg/FFmpeg.hpp
@@ -24,19 +24,19 @@
 
 class QComboBox;
 
-class FFmpeg final : public Module
+class FFmpeg : public Module
 {
     Q_DECLARE_TR_FUNCTIONS(FFmpeg)
 public:
     FFmpeg();
     ~FFmpeg();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const;
+    void *createInstance(const QString &);
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget();
 
-    void videoDeintSave() override;
+    void videoDeintSave();
 
     /**/
 
@@ -70,13 +70,13 @@ class QGroupBox;
 class QSpinBox;
 class Slider;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &module, bool vkVideo, bool dxva2, bool d3d11va);
 private:
-    void saveSettings() override;
+    void saveSettings();
 
     QGroupBox *demuxerB;
     QCheckBox *reconnectNetworkB;
